
precision mediump float;
precision mediump int;
precision lowp sampler2D;
precision lowp samplerCube;

//"in" attributes from our vertex shader
varying vec4 vColor;
varying vec2 vTexCoord;

//declare uniforms
uniform sampler2D u_texture;
uniform sampler2D uTexRandom;

uniform float resolutionW;
uniform float resolutionH;
uniform float radius;//the amount to blur, in pixels
uniform vec4 Color2;


const int uSampleKernelSize = 17;
uniform vec3 uSampleKernel[17];
//float a[5] = float[5](3.4, 4.2, 5.0, 5.2, 1.1);
//uniform vec3 uSampleKernel[5];
 //= {
  //          vec3(0.0, 0.0, 0.2270270270),
  //          vec3(1.0, 1.0, 0.1945945946),
   //         vec3(2.0, 2.0, 0.1216216216),
   //         vec3(3.0, 3.0, 0.0540540541),
   //         vec3(4.0, 4.0, 0.0162162162)};


//float rand(vec2 n)
//{
//  return 0.5 + 0.5 *
//     fract(sin(dot(n.xy, vec2(12.9898, 78.233)))* 43758.5453);
//}

void main() {


//vec3 uSampleKernel[17];
  // uSampleKernel[0] =  vec3(0.0, 0.0, 0.2270270270);
  // uSampleKernel[1] =  vec3(1.0, 1.0, 0.1945945946);
  // uSampleKernel[2] =  vec3(2.0, 2.0, 0.1216216216);
  // uSampleKernel[3] =  vec3(3.0, 3.0, 0.0540540541);
   //uSampleKernel[4] =  vec3(4.0, 4.0, 0.0162162162);

     // uSampleKernel[5] =  vec3(-1.0, -1.0, 0.1945945946);
    // uSampleKernel[6] =  vec3(-2.0, -2.0, 0.1216216216);
    // uSampleKernel[7] =  vec3(-3.0, -3.0, 0.0540540541);
    //  uSampleKernel[8] =  vec3(-4.0, -4.0, 0.0162162162);

     // uSampleKernel[9] =  vec3(1.0, -1.0, 0.1945945946);
     // uSampleKernel[10] =  vec3(2.0, -2.0, 0.1216216216);
    // uSampleKernel[11] =  vec3(3.0, -3.0, 0.0540540541);
     // uSampleKernel[12] =  vec3(4.0, -4.0, 0.0162162162);

        //    uSampleKernel[13] =  vec3(-1.0, 1.0, 0.1945945946);
        //    uSampleKernel[14] =  vec3(-2.0, 2.0, 0.1216216216);
        //   uSampleKernel[15] =  vec3(-3.0, 3.0, 0.0540540541);
         //   uSampleKernel[16] =  vec3(-4.0, 4.0, 0.0162162162);

	vec4 sum = vec4(0.0);

	vec2 tc = vTexCoord;

	float blurW = radius/resolutionW;
    float blurH = radius/resolutionH;

	float vstep = 1.0;

    //apply blurring, using a 9-tap filter with predefined gaussian weights
	//sum += texture2D(u_texture, vec2(tc.x, tc.y - 4.0*blurH*vstep)) * 0.0162162162;
	//sum += texture2D(u_texture, vec2(tc.x, tc.y - 3.0*blurH*vstep)) * 0.0540540541;
	//sum += texture2D(u_texture, vec2(tc.x, tc.y - 2.0*blurH*vstep)) * 0.1216216216;
	//sum += texture2D(u_texture, vec2(tc.x, tc.y - 1.0*blurH*vstep)) * 0.1945945946;

	//sum += texture2D(u_texture, vec2(tc.x, tc.y)) * 0.2270270270;

	//sum += texture2D(u_texture, vec2(tc.x, tc.y + 1.0*blurH*vstep)) * 0.1945945946;
	//sum += texture2D(u_texture, vec2(tc.x, tc.y + 2.0*blurH*vstep)) * 0.1216216216;
	//sum += texture2D(u_texture, vec2(tc.x, tc.y + 3.0*blurH*vstep)) * 0.0540540541;
	//sum += texture2D(u_texture, vec2(tc.x, tc.y + 4.0*blurH*vstep)) * 0.0162162162;


	    vec3 normal = vec3(0.0, 0.0, 1.0);
        vec3 rvec = texture2D(uTexRandom, vec2( vTexCoord.x*((resolutionW * 4.0)/ 16.0) , vTexCoord.y*((resolutionH* 4.0)/ 16.0))).xyz * 2.0 - 1.0;

//vec3 rvec = vec3(1.0, 0.0 ,0.0);
        //vec3 rvec = vec3(rand(vTexCoord), rand(vTexCoord), 0.0);
        vec3 tangent = normalize(rvec - normal * dot(rvec, normal));
        vec3 bitangent = cross(normal, tangent);
        mat3 tbn = mat3(tangent, bitangent, normal);

	//gl_FragColor = vec4(rvec, 1.0);
float w;
 vec3 offset;
    for (int i = 0; i < uSampleKernelSize; ++i) {
       offset = uSampleKernel[i];
       w = offset.z;
       offset = tbn * vec3(offset.xy, 0.0);
       sum += texture2D(u_texture, vec2(tc.x + offset.x*blurW, tc.y + offset.y*blurH)) * w;
    }

    gl_FragColor = sum;
}